###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2006 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
Source10: kmodtool2
%define kmodtool bash %{SOURCE10}
%{!?kversion: %define kversion 2.6.18-8.1.1.el5}
# hint: this can he overridden with "--define kversion foo" on the rpmbuild command line, e.g.
# --define "kversion 2.6.16-1.2096_FC5"

%define kmod_name gnbd
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""
%ifarch ppc
%define smpvar smp
%endif
%ifarch i686 x86_64 ia64
%define xenvar xen
#define kdumpvar kdump
%endif
%ifarch i686
%define PAEvar PAE
%endif
%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?xenvar} %{?kdumpvar} %{?PAEvar}}
# hint: this can he overridden with "--define kvariant foo bar" on the rpmbuild command line, e.g.
# --define 'kvariant "" smp' 

Name:           %{kmod_name}-kmod
Version:        0.1.3
Release:        4.%(echo %{kverrel} | tr - _)
Summary:        %{kmod_name} kernel modules

Group:          System Environment/Kernel
License:        GPL
URL:            http://sources.redhat.com/cluster
Source0:        gnbd-kernel-%{version}.tar.gz
Patch1:		gnbd-kernel-makefix.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:  i686 x86_64 ia64 ppc64 ppc64iseries s390x
# Temporarily disable s390 & ppc

%description
gnbd - The Global Network Block Device

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}


%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0
pushd %{kmod_name}-kernel-%{version}*
%patch1 -p1 -b .makefix
popd
for kvariant in %{kvariants} ; do
    cp -a %{kmod_name}-kernel-%{version} _kmod_build_${kvariant}
done


%build
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant
    ./configure --kernel_src=${ksrc} --libdir=%{_libdir} --incdir=%{_includedir}
    make -C "${ksrc}" SUBDIRS=${PWD} modules %{?_smp_mflags}
    popd
done


%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}
do
    pushd _kmod_build_$kvariant
    make install \
         DESTDIR=$RPM_BUILD_ROOT
         INST_DIR=$RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}
    popd
done
# Temporarily executable for stripping, fixed later in %%files.
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Thu Mar 18 2007 Chris Feist <cfeist@redhat.com> - 0.1.3-4
- Build for 2.6.18-8.1.1.el5 kernel
- Resolves: rhbz#231251

* Mon Jan 15 2007 Chris Feist <cfeist@redhat.com> - 0.1.3-2
- Now requires kABI rather than specific kernel (code from
  jcm@redhat.com)
- Resolves: rhbz#212428

* Fri Dec 08 2006 Chris Feist <cfeist@redhat.com> - 0.1.2-5
- New upstream sources
- Resolves: rhbz#212428

* Fri Dec 08 2006 Chris Feist <cfeist@redhat.com> - 0.1.2-5
- Built for PAE kernel
- Resolves: rhbz#218986

* Mon Dec 04 2006 Chris Feist <cfeist@redhat.com> - 0.1.2-3
- Built for new kernel
- Resolves: rhbz#217893

* Thu Nov 28 2006 Chris Feist <cfeist@redhat.com> - 0.1.2-2
- Built for new kernel
- Resolves: rhbz#217893

* Tue Nov 21 2006 Chris Feist <cfeist@redhat.com> - 0.1.2-1
- New upstream sources.

* Fri Oct 06 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-12
- Don't build for ppc.

* Mon Sep 25 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-9
- Add support for ia64 xen.

* Thu Sep 21 2006 Tim Powers <timp@redhat.com> - 0.1.1-8
- rebuild for kernel-2.6.18-1.2685.el5

* Wed Sep 20 2006 Tim Powers <timp@redhat.com> - 0.1.1-7
- rebuild for 2.6.17-1.2677.el5

* Mon Sep 18 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-6
- Enable xen builds.

* Fri Aug 25 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-5
- Don't build kernel-kmod package.

* Fri Aug 18 2006 Tim Powers <timp@redhat.com> - 0.1.1-4
- bump and rebuild against kernel-2.6.17-1.2519.4.5.el5

* Thu Aug 15 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-3
- Build for new kernel.

* Tue Aug 15 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-2
- Don't require -common package for now.

* Tue Aug 15 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-0
- New upstream sources

* Fri Aug 4 2006 Chris Feist <cfeist@redhat.com> - 0.1.0-3
- Renamed .spec file to gnbd-kmod.spec
- Re-enable other kernel types & disabled broken xen build

* Thu Aug 3 2006 Chris Feist <cfeist@redhat.com> - 0.1.0-2
- Initial Build
